/*  COMICS ORGANIZER             */
/*  Simple header file for comic node definition  */

/* List Type Definitions -------------------------------------- */

#define TITLELEN 30
#define ARTISTLEN 100
#define NOTESLEN 150

struct ComicNode
{
	char	Title[TITLELEN];
	int	Issue;
	char	Date[7];
	char	Artist[ARTISTLEN];
	float	Cover;
	float	Purchase;
	float	Current;
	float	Profit;
	char	Notes[NOTESLEN];
	char	Condition[15];
	char	Publisher[15];
	char	Format[15];
	int	Copies;
	
	struct ComicNode *next;
	struct ComicNode *prev;
};

typedef struct ComicNode *ComicNodePtr;


/* File Variable structure ------------------------------------ */

struct ComicFile
{
	char	FileName[108];		/* default file name */
	char	FilePath[108];		/* Path for filename */
	char	Reportfile[108];	/* filename for reports output */
	BOOL	Changed;		/* Issue has been changed? */
	BOOL	WorkSaved;		/* current changes are saved? */
	int	defCopies;		/* defaults  */
	char	defPublisher[12];
	char	defCondition[12];
	char	defFormat[12];
	int	TotalIssues;		/* total number of issues */
	USHORT	ColorMap[4];		/* Colors */
	BOOL	ChangeThe;		/* Menu options */
	BOOL	AutoUpdate;		/* Automatic update mode */
	USHORT	Update;			/* Update date, prices, notes */
};
		
#define UPDATEDATE 1
#define UPDATEPRICES 2
#define UPDATENOTES 4

/*  INDEX DEFINES & STRUCTURES ------------------------------------- */

#define TITLEINDEX TRUE
#define ISSUEINDEX FALSE

#define INDEXHEIGHT 16  /* No of lines available in index window */
#define INDEXWIDTH  20  /* No of columns available in index window */

/* Add 1 pixel to text height for space between chars */
#define TEXTHEIGHT (IndexWindow->RPort->TxHeight + 1)
#define BASELINE (IndexWindow->RPort->TxBaseline)
#define WINDOWTOP 12L
#define WINDOWLEFT 3L
#define WINDOWBOTTOM (WINDOWTOP + INDEXHEIGHT*TEXTHEIGHT)
#define WINDOWRIGHT 170L

struct IndexLine
{
	char string[INDEXWIDTH+1];
	struct IndexLine *prev;
	struct IndexLine *next;
};

typedef struct IndexLine *IndexPtr;

struct IndexDisplay
{
	char     Title[30];	/* Title of window */
	IndexPtr top;		/* Current top line in index */
	IndexPtr bottom;	/* Current bottom line in index */
	IndexPtr head;		/* start of index entries */
	int      Lines;		/* number of entries in index */
	int	 CurLine;	/* current line number */
	char	 sttitle[100];	/* title, for Issue Index */
};


/*  DEFINES ---------------------------------------- */

#define ISSUEMENU 29		/* Position in Items[] array */
#define TITLEMENU 30

#define INDEXMSG FALSE
#define MAINMSG TRUE
#define MAINPROPGAD 4    /* Gadget IDs */
#define INDEXPROPGAD 22

/*  Raw key codes                   */
#define RETURN 0x0044
#define ESC    0x0045
#define DELETE 0x0046
#define UP     0x004c
#define DOWN   0x004d
#define RIGHT  0x004e
#define LEFT   0x004f
#define TAB    0x0042
#define F1     0x0050
#define F2     0x0051
#define F8     0x0057
#define F9     0x0058
#define F10    0x0059
#define HELP   0x005f
#define SPACE  0x0040
#define UPDATEKEY 0x0000	/* (`) key */
#define FINDKEY 0x0023          /* (f) key */
#define NUM1   0x0001
#define NUM9   0x0009

/*  "Other Gadgets"  ---------------------------------- */

#define FIRSTFORMAT 14         /*  Offsets for SubItemsText[] array */
#define LASTFORMAT 19
#define FIRSTCOND 7
#define LASTCOND 13
#define FIRSTPUB 0
#define LASTPUB 6

#define OPTLENGTH 11
