/*  COMICS ORGANIZER   */
/*  Defaults menu routines   */

#include <exec/types.h>
#include <exec/memory.h>
#include <libraries/dos.h>
#include <intuition/intuition.h>
#include <proto/exec.h>
#include <proto/dos.h>

#include <stdio.h>
#include <libraries/reqtools.h>
#include <proto/reqtools.h>

#include "comics.h"

/*  External variables ---------------------------------- */

extern struct ComicFile Comics;
extern struct IntuiText SubItemsText[];
extern struct Menu	MenuStrip[];
extern struct Window	*MainWindow;

extern ULONG BuildRequester(USHORT,USHORT,char *,BOOL);  /* From list.c */

/*  Routine prototypes ---------------------------------- */

void SetDefault(char *,USHORT,UWORD);
void SetDefCopies();
void ChangeMenuItem(UWORD);


void SetDefault(thestring,FirstVal,SubItem)
char *thestring;
USHORT FirstVal;
UWORD SubItem;
{
	char menuname[25];
	     
	strcpy (menuname,SubItemsText[FirstVal + (USHORT) SubItem].IText);
	strcpy (thestring,&menuname[2]);  /* chop off leading spaces */
}

void ChangeMenuItem(SubItem)
UWORD SubItem;
{
	USHORT FirstVal,LastVal;
	ULONG  theanswer,response;
	char   inputbuf[12],NewMenuName[15];

	switch(SubItem)
	{
		case 0 : FirstVal = FIRSTPUB;
			 LastVal = LASTPUB;
			 break;
		case 1 : FirstVal = FIRSTCOND;
			 LastVal = LASTCOND;
			 break;
		case 2 : FirstVal = FIRSTFORMAT;
			 LastVal = LASTFORMAT;
			 break;
	}
	
	theanswer = BuildRequester(FirstVal,LastVal,"Change which item?",FALSE);
	
	if (theanswer)
	{
		/* Subtract 1 to make offset of FirstVal */
		theanswer -= 1;
		
		strcpy (inputbuf,SubItemsText[FirstVal + (USHORT) theanswer].IText + 2);
		response =
			rtGetString(inputbuf,OPTLENGTH,"Enter new text",NULL,
				    RT_ReqPos,REQPOS_CENTERSCR,TAG_END);
		if (response)
		{
			/* Put in 2 leading spaces */
			sprintf (NewMenuName,"  %s",inputbuf);
			/* Pad with trailing spaces */
			while (strlen(NewMenuName) < OPTLENGTH + 2)
				strcat (NewMenuName," ");
			/* Copy it into the IntuiText structure */
			strcpy (SubItemsText[FirstVal + (USHORT) theanswer].IText,NewMenuName);
			ClearMenuStrip(MainWindow);
			SetMenuStrip(MainWindow,MenuStrip);
		}
	}
}

void SetDefCopies()
{
	ULONG theanswer;
	LONG  copies;
	
	copies = (LONG) Comics.defCopies;
	theanswer = rtGetLong (&copies,"Default copies:",NULL,
				RTGL_Min,1L,RTGL_Max,1000L,
				RT_ReqPos,REQPOS_CENTERSCR,TAG_END);

	if (theanswer)
		Comics.defCopies = (int) copies;
}
