/*  Comics Organizer Program          */
/*  Data and routines for FIND        */

#include <intuition/intuition.h>

#include "comics.h"

/*---------------------------------------------------*
  Gadgets created with PowerSource V3.0
  which is (c) Copyright 1990-91 by Jaba Development
  written by Jan van den Baard
 *---------------------------------------------------*/

/* IMAGE DATA MUST BE LOCATED IN CHIP MEMORY!!! */

USHORT chip RadioOnData[] = {
  0x0000,  0x1FC0,  0x7070,  0x6030,  0x7070,  0x1FC0,  0x0000,  0x1FC0,
  0x6030,  0x8F88,  0x9FC8,  0x8F88,  0x6030,  0x1FC0 }; 

struct Image RadioOn = {
  0,0,13,7,2,(USHORT *)&RadioOnData[0],0x03,0x00,NULL };

USHORT chip RadioOffData[] = {
  0x0000,  0x1FC0,  0x7FF0,  0x7FF0,  0x7FF0,  0x1FC0,  0x0000,  0x1FC0,
  0x6030,  0x8008,  0x8008,  0x8008,  0x6030,  0x1FC0 }; 

struct Image RadioOff = {
  0,0,13,7,2,(USHORT *)&RadioOffData[0],0x03,0x00,NULL };

SHORT FindRenderBordersPairs0[] = {
  0,0,0,68,1,67,1,0,337,0 };
SHORT FindRenderBordersPairs1[] = {
  1,68,337,68,337,1,338,0,338,68 };
SHORT FindRenderBordersPairs2[] = {
  -1,-1,364,-1,364,93,-1,93,-1,-1 };
SHORT FindRenderBordersPairs3[] = {
  -1,-1,362,-1,362,92,-1,92,-1,-1 };

struct Border FindRenderBorders[] = {
  11,5,2,0,JAM1,5,(SHORT *)&FindRenderBordersPairs0[0],&FindRenderBorders[1],
  11,5,1,0,JAM1,5,(SHORT *)&FindRenderBordersPairs1[0],&FindRenderBorders[2],
  1,1,2,0,JAM1,5,(SHORT *)&FindRenderBordersPairs2[0],&FindRenderBorders[3],
  1,1,2,0,JAM1,5,(SHORT *)&FindRenderBordersPairs3[0],NULL };

SHORT FindSharedBordersPairs0[] = {
  0,0,0,11,1,10,1,0,109,0 };
SHORT FindSharedBordersPairs1[] = {
  1,11,109,11,109,1,110,0,110,11 };
SHORT FindSharedBordersPairs2[] = {
  -1,-1,302,-1,302,9,-1,9,-1,-1 };

struct Border FindSharedBorders[] = {
  0,0,1,0,JAM1,5,(SHORT *)&FindSharedBordersPairs0[0],&FindSharedBorders[1],
  0,0,2,0,JAM1,5,(SHORT *)&FindSharedBordersPairs1[0],NULL,
  0,0,3,0,JAM1,5,(SHORT *)&FindSharedBordersPairs2[0],NULL };

struct IntuiText FindRenderTexts[] = {
  1,1,JAM1,98,10,NULL,(UBYTE *)"Enter Search String:",&FindRenderTexts[1],
  2,1,JAM1,149,79,NULL,(UBYTE *)"From start",&FindRenderTexts[2],
  2,1,JAM1,47,36,NULL,(UBYTE *)"Title",&FindRenderTexts[3],
  2,1,JAM1,48,47,NULL,(UBYTE *)"Artists",&FindRenderTexts[4],
  2,1,JAM1,49,58,NULL,(UBYTE *)"Notes",&FindRenderTexts[5],
  2,1,JAM1,160,36,NULL,(UBYTE *)"Publisher",&FindRenderTexts[6],
  2,1,JAM1,160,47,NULL,(UBYTE *)"Format",&FindRenderTexts[7],
  2,1,JAM1,234,61,NULL,(UBYTE *)"Exact Match",NULL };

#define FindExactGad_ID    39

struct Gadget FindExactGad = {
  NULL,214,61,13,7,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  NULL,NULL,NULL,FindExactGad_ID,NULL };

#define FindFormGad_ID    38

struct Gadget FindFormGad = {
  &FindExactGad,136,47,13,7,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  NULL,NULL,NULL,FindFormGad_ID,NULL };

#define FindPubGad_ID    37

struct Gadget FindPubGad = {
  &FindFormGad,136,36,13,7,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  NULL,NULL,NULL,FindPubGad_ID,NULL };

#define FindNotesGad_ID    36

struct Gadget FindNotesGad = {
  &FindPubGad,28,58,13,7,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  NULL,NULL,NULL,FindNotesGad_ID,NULL };

#define FindArtistGad_ID    35

struct Gadget FindArtistGad = {
  &FindNotesGad,28,47,13,7,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  NULL,NULL,NULL,FindArtistGad_ID,NULL };

#define FindTitleGad_ID    34

struct Gadget FindTitleGad = {
  &FindArtistGad,28,36,13,7,
  GADGHIMAGE+GADGIMAGE+SELECTED,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  NULL,NULL,NULL,FindTitleGad_ID,NULL };

#define FindStartGad_ID    33

struct Gadget FindStartGad = {
  &FindTitleGad,131,79,13,7,
  GADGHIMAGE+GADGIMAGE,
  TOGGLESELECT+RELVERIFY,
  BOOLGADGET+REQGADGET,
  (APTR)&RadioOff,(APTR)&RadioOn,
  NULL,NULL,NULL,FindStartGad_ID,NULL };

UBYTE FindStringGad_buf[100];

struct StringInfo FindStringGad_info = {
  (UBYTE *)&FindStringGad_buf[0],NULL,0,100,0,0,0,0,0,0,NULL,NULL,NULL };

#define FindStringGad_ID    32

struct Gadget FindStringGad = {
  &FindStartGad,30,21,302,9,
  GADGHCOMP,
  RELVERIFY+STRINGCENTER+ENDGADGET,
  STRGADGET+REQGADGET,
  (APTR)&FindSharedBorders[2],NULL,
  NULL,NULL,(APTR)&FindStringGad_info,FindStringGad_ID,NULL };

struct IntuiText FindCancelGad_text = {
  2,2,JAM1,31,2,NULL,(UBYTE *)"Cancel",NULL };

#define FindCancelGad_ID    31

struct Gadget FindCancelGad = {
  &FindStringGad,240,77,111,12,
  GADGHCOMP,
  RELVERIFY+ENDGADGET,
  BOOLGADGET+REQGADGET,
  (APTR)&FindSharedBorders[0],NULL,
  &FindCancelGad_text,NULL,NULL,FindCancelGad_ID,NULL };

struct IntuiText FindOKGad_text = {
  2,2,JAM1,28,2,NULL,(UBYTE *)"Find...",NULL };

#define FindOKGad_ID    30

struct Gadget FindOKGad = {
  &FindCancelGad,11,77,111,12,
  GADGHCOMP,
  RELVERIFY+ENDGADGET,
  BOOLGADGET+REQGADGET,
  (APTR)&FindSharedBorders[0],NULL,
  &FindOKGad_text,NULL,NULL,FindOKGad_ID,NULL };

struct Requester FindRequester = {
  NULL,55,23,366,95,0,0,
  &FindOKGad,&FindRenderBorders[0],&FindRenderTexts[0],
  NULL,0,NULL,NULL,NULL,NULL,NULL };


/*  PROTOTYPES ------------------------------------ */

void FindComic();
void FindText();
BOOL CompareStrings(char *,char *,BOOL);

extern void ConvertStr(char *);

/*  GLOBAL VARIABLES ------------------------------ */

extern ComicNodePtr	head,current;
extern int		CurIssue;
extern struct Window	*MainWindow;
extern struct ComicFile Comics;

  /* used to set which field is searched */
#define TITLEFLD 1
#define ARTISTFLD 2
#define NOTESFLD 4
#define PUBFLD 8
#define FORMFLD 16

USHORT whatfields = TITLEFLD+ARTISTFLD+NOTESFLD; /* search in which fields */
BOOL   exactmatch = FALSE;	/* search for exact match */
BOOL   starthead = FALSE;	/* search from beginning */

/*  ROUTINES --------------------------------------- */

void FindComic()
{
	BOOL itworked = FALSE,closerequester = FALSE;
	ULONG class;
	USHORT GadgetID;
	struct Gadget	*GadgetPtr;
	struct IntuiMessage	*reqmessage;
	
	if (head == NULL) return;
	
	itworked = Request(&FindRequester,MainWindow);
	
	if (!itworked)
	{
		SetWindowTitles(MainWindow,-1,"Cannot open find requester!");
		return;
	}
	
	/* Wait for requester to become active, set string gadget */
	while (!(FindRequester.Flags & REQACTIVE));
	ActivateGadget(&FindStringGad,MainWindow,&FindRequester);
	
	starthead = (FindStartGad.Flags & SELECTED);
	
	while (!closerequester)
	{
	    if ((reqmessage = (struct IntuiMessage *)
		GetMsg(MainWindow->UserPort)) == NULL)
		{
		    Wait(1L << MainWindow->UserPort->mp_SigBit);
		    continue;
		}
		
	    class = reqmessage->Class;
	    GadgetPtr = (struct Gadget *) reqmessage->IAddress;
	    GadgetID = GadgetPtr->GadgetID;
		
	    ReplyMsg(reqmessage);
	    
	    if (class & GADGETUP)
		switch(GadgetID)
		{
			case FindStringGad_ID : if (FindStringGad_buf[0])
						{  closerequester = TRUE;
					           itworked = TRUE;  }
					        break;
			case FindOKGad_ID     : if (FindStringGad_buf[0])
						{  closerequester = TRUE;
					           itworked = TRUE;  }
					        break;
			case FindCancelGad_ID : closerequester = TRUE;
					        itworked = FALSE;
					        break;
			case FindStartGad_ID  : starthead =
					        (GadgetPtr->Flags & SELECTED);
						break;
			case FindExactGad_ID  : exactmatch = 
					        (GadgetPtr->Flags & SELECTED);
					        break;
			case FindTitleGad_ID  : whatfields ^= TITLEFLD;
					        break;
			case FindArtistGad_ID : whatfields ^= ARTISTFLD;
					        break;
			case FindNotesGad_ID  : whatfields ^= NOTESFLD;
					        break;
			case FindPubGad_ID    : whatfields ^= PUBFLD;
						break;
			case FindFormGad_ID   : whatfields ^= FORMFLD;
						break;
		}
	    
	    if (class & REQCLEAR)	closerequester = TRUE;
	}
	
	EndRequest(&FindRequester,MainWindow);
	
	if (itworked)
	{
		FindText();
	}
}

void FindText()
{
	register ComicNodePtr cur;
	BOOL foundit = FALSE;
	char comparestr[150];
	int NewCurIssue;
	char *string;
	
	if (FindStringGad_buf[0] == 0)	return;   /* search string empty */
	
	string = (char *) &FindStringGad_buf[0];
	ConvertStr(string);
	
	if (Comics.Changed)	SaveComic();
	
	if (starthead)
	{
		cur = head;
		NewCurIssue = 1;
	}
	else
	{
		cur = current->next;
		NewCurIssue = CurIssue + 1;
	}
	
	while ((cur != NULL) && (foundit == FALSE))
	{
	    if (whatfields & TITLEFLD)
	    {
		strcpy (comparestr,cur->Title);
		foundit = CompareStrings(comparestr,string,exactmatch);
	    }
	    if ((!foundit) && (whatfields & ARTISTFLD))
	    {
		strcpy (comparestr,cur->Artist);
		foundit = CompareStrings(comparestr,string,exactmatch);
	    }
	    if ((!foundit) && (whatfields & NOTESFLD))
	    {
		strcpy (comparestr,cur->Notes);
		foundit = CompareStrings(comparestr,string,exactmatch);
	    }
	    if ((!foundit) && (whatfields & PUBFLD))
	    {
		strcpy (comparestr,cur->Publisher);
		foundit = CompareStrings(comparestr,string,exactmatch);
	    }
	    if ((!foundit) && (whatfields & FORMFLD))
	    {
		strcpy (comparestr,cur->Format);
		foundit = CompareStrings(comparestr,string,exactmatch);
	    }
	    if (!foundit)
	    {
		cur = cur->next;
	        NewCurIssue++;
	    }
	}
	
	if (foundit)
	{
		current = cur;
		CurIssue = NewCurIssue;
		DisplayComic();
	}
	else
	{
		SetWindowTitles(MainWindow,"Not found.",-1);
	}
}

BOOL CompareStrings(string1,string2,exactly)
char *string1,*string2;
BOOL exactly;
{
	BOOL itworked;
	register int i;
	int thelength,comparelength;
	
	ConvertStr(string1);
	comparelength = strlen(string2);
	
	if (exactly)
	{
		return ((BOOL) (strcmp(string1,string2) == 0));
	}
	else
	{
		itworked = FALSE;
		i = 0;
		thelength = strlen(string1)-strlen(string2);
		while ((itworked == FALSE) && (i <= thelength))
		{
			itworked = 
			(strncmp(string1+i++,string2,comparelength) == 0);
		}
		return(itworked);
	}
}
