/*  Comics  Organizer                   */
/*  Data and Routines for Index window (s)  */

/* Thanks to Peter Cherna for routines to calculate prop gadget settings */

#include <intuition/intuition.h>
#include <exec/types.h>
#include <exec/memory.h>

#include "comics.h"


/*---------------------------------------------------*
  Gadgets created with PowerSource V3.0
  which is (c) Copyright 1990-91 by Jaba Development
  written by Jan van den Baard
 *---------------------------------------------------*/

/* IMAGE DATA MUST BE LOCATED IN CHIP MEMORY!!! */

USHORT chip IndexImagesData0[] = {
  0x0000,  0x0000,  0x7FFF,  0xFC00,  0x7FCF,  0xFC00,  0x7F87,  0xFC00,
  0x7F03,  0xFC00,  0x7E01,  0xFC00,  0x7C00,  0xFC00,  0x7800,  0x7C00,
  0x7000,  0x3C00,  0x7FFF,  0xFC00,  0x0000,  0x0000,  0xFFFF,  0xFE00,
  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,
  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,
  0xFFFF,  0xFE00,  0xFFFF,  0xFE00 }; 

struct Image IndexImages0 = {
  0,0,23,11,2,(USHORT *)&IndexImagesData0[0],0x03,0x00,NULL };

USHORT chip IndexImagesData1[] = {
  0x0000,  0x0000,  0x7FFF,  0xFC00,  0x7000,  0x3C00,  0x7800,  0x7C00,
  0x7C00,  0xFC00,  0x7E01,  0xFC00,  0x7F03,  0xFC00,  0x7F87,  0xFC00,
  0x7FCF,  0xFC00,  0x7FFF,  0xFC00,  0x0000,  0x0000,  0xFFFF,  0xFE00,
  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,
  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,  0xFFFF,  0xFE00,
  0xFFFF,  0xFE00,  0xFFFF,  0xFE00 }; 

struct Image IndexImages1 = {
  0,0,23,11,2,(USHORT *)&IndexImagesData1[0],0x03,0x00,NULL };

SHORT IndexSharedBordersPairs0[] = {
  0,0,0,11,1,10,1,0,161,0 };
SHORT IndexSharedBordersPairs1[] = {
  1,11,161,11,161,1,162,0,162,11 };

struct Border IndexSharedBorders[] = {
  0,0,2,0,JAM1,5,(SHORT *)&IndexSharedBordersPairs0[0],&IndexSharedBorders[1],
  0,0,1,0,JAM1,5,(SHORT *)&IndexSharedBordersPairs1[0],NULL };

struct IntuiText UpdateIndex_text = {
  2,0,JAM1,31,2,NULL,(UBYTE *)"Update Index",NULL };

#define UpdateIndex_ID    23

struct Gadget UpdateIndex = {
  NULL,6,164,163,12,
  GADGHCOMP,
  RELVERIFY,
  BOOLGADGET,
  (APTR)&IndexSharedBorders[0],NULL,
  &UpdateIndex_text,NULL,NULL,UpdateIndex_ID,NULL };

struct PropInfo IndexProp_info = {
  AUTOKNOB+FREEVERT,0x0000,0xFFFF,0xFFFF,0xFFFF,0,0,0,0,0,0 };

struct Image IndexProp_image;

#define IndexProp_ID    22

struct Gadget IndexProp = {
  &UpdateIndex,171,19,23,150,
  GADGHCOMP,
  RELVERIFY,
  PROPGADGET,
  (APTR)&IndexProp_image,NULL,
  NULL,NULL,(APTR)&IndexProp_info,IndexProp_ID,NULL };

#define IndexDown_ID    21

struct Gadget IndexDown = {
  &IndexProp,171,168,23,11,
  GADGHCOMP+GADGIMAGE,
  RELVERIFY,
  BOOLGADGET,
  (APTR)&IndexImages1,NULL,
  NULL,NULL,NULL,IndexDown_ID,NULL };

#define IndexUp_ID    20

struct Gadget IndexUp = {
  &IndexDown,171,9,23,11,
  GADGHCOMP+GADGIMAGE,
  RELVERIFY,
  BOOLGADGET,
  (APTR)&IndexImages0,NULL,
  NULL,NULL,NULL,IndexUp_ID,NULL };

struct NewWindow Index_window = {
  0,14,195,179,1,2,
  GADGETUP+CLOSEWINDOW+MOUSEBUTTONS+MENUPICK+ACTIVEWINDOW
  +RAWKEY+VANILLAKEY,
  WINDOWDRAG+WINDOWCLOSE+NOCAREREFRESH+SMART_REFRESH,
  &IndexUp,NULL,
  (UBYTE *)"Index",NULL,NULL,
  150,50,640,200,CUSTOMSCREEN };


/*  Prototypes ------------------------------- */

void MakeIssueIndex(),MakeTitleIndex();
IndexPtr NEWIndex();
void DisposeIndex();
void IndexDisplay(),UpdateIndexProp();
void ReadIndexProp();
ComicNodePtr FindNextTitle(ComicNodePtr);
void IndexScrollUp(),IndexScrollDown(),IndexHome();
void GotoIssue(SHORT),GotoTitle(SHORT);
char *SelectLine(SHORT);
void IndexKeyAdvance(char);

extern void SaveComic();

/*  Global Variables ------------------------- */

struct IndexDisplay theIndex;

extern struct Window *IndexWindow;
extern struct Window *MainWindow;
extern ComicNodePtr head,current,previous;
extern struct ComicFile	Comics;
extern int	CurIssue;

/*  INDEX ROUTINES ------------------------------------------ */

IndexPtr NEWIndex()
/*  Allocates space for a new index line and returns a pointer to the
    space  */
{
	IndexPtr newpointer;
	
	newpointer = (IndexPtr) AllocMem(sizeof(struct IndexLine),MEMF_CLEAR);
	if (!newpointer)
	{
		rtEZRequest ("ERROR: Couldn't create index!\nOut of memory?","ABORT",NULL,NULL);
	}
		
	return (newpointer);
}

void DisposeIndex()
/*  Clears all index entries in memory; harmless if there are none */
{
	register IndexPtr cur,next;
	
	cur = theIndex.head;
	while (cur != NULL)
	{
		next = cur->next;
		FreeMem(cur,sizeof(struct IndexLine));
		cur = next;
	}
	theIndex.head = NULL;
	theIndex.top = NULL;
	theIndex.bottom = NULL;
	theIndex.Lines = 0;
}


/*  INDEX CREATION ROUTINES ------------------------------------ */

void MakeTitleIndex()
{
	register ComicNodePtr	cur;
	register IndexPtr	entryptr;
	IndexPtr		prev;
	
	rtSetWaitPointer(IndexWindow);
	
	/*  If an index already exists, destroy it  */
	DisposeIndex();
	
	/*  Create the Index entries  */
	theIndex.Lines = 0;
	theIndex.head = NULL;
	
	cur = head;
	prev = NULL;
	while (cur != NULL)
	{
		entryptr = NEWIndex();
		if (entryptr != NULL)
		{	
			theIndex.Lines++;
			strncpy (entryptr->string,cur->Title,INDEXWIDTH);
			entryptr->next = NULL;
			entryptr->prev = prev;
			
			if (prev == NULL)	/* First entry in list */
				theIndex.head = entryptr;
			else
				prev->next = entryptr;
			
			prev = entryptr;
		}
		cur = FindNextTitle(cur);
	}
	
	sprintf (theIndex.Title,"%d titles",theIndex.Lines);

	IndexHome();
	ClearPointer(IndexWindow);
}

ComicNodePtr FindNextTitle(cur)
ComicNodePtr cur;
/* Returns a pointer to the next different title after cur 
   or NULL if there's not one */
{
	char curstr[100],comparestr[100];
	BOOL success;
	
	strcpy (comparestr,cur->Title);
	ConvertStr(comparestr);
	success = FALSE;
	cur = cur->next;
	
	while ( (success == FALSE) && (cur != NULL) )
	{
		strcpy (curstr,cur->Title);
		ConvertStr(curstr);
		if (strcmp(curstr,comparestr) != 0)
			success = TRUE;
		else
			cur = cur->next;
	}
	return(cur);
}

void MakeIssueIndex()
{
	register ComicNodePtr	cur,lastnode;
	register IndexPtr	entryptr;
	IndexPtr		prev;
	char			comparestr[150];
	
	rtSetWaitPointer(IndexWindow);
	
	/*  If an index already exists, destroy it  */
	DisposeIndex();
	
	/*  Create the Index entries  */
	theIndex.Lines = 0;
	theIndex.head = NULL;
	
	/* Set cur = the first node of the current title */
	strcpy (theIndex.sttitle,current->Title);  /* for GotoIssue */
	ConvertStr(theIndex.sttitle);

	cur = head;
	if (head != NULL)
	{	strcpy (comparestr,head->Title);
		ConvertStr(comparestr);			}
	
	while ( (cur != NULL) &&
	        (strcmp (theIndex.sttitle,comparestr) != 0) )
	{
		cur = FindNextTitle(cur);
		strcpy (comparestr,cur->Title);
		ConvertStr(comparestr);
	}
	
	/* Find the first node of the next title, which will be the
	   end of our issue index */
	lastnode = cur;
	lastnode = FindNextTitle(lastnode);
	
	prev = NULL;
	while ((cur != NULL) && (cur != lastnode))
	{
		if ( (entryptr = NEWIndex()) != NULL );
		{	
			theIndex.Lines++;
			sprintf(entryptr->string,"%d : %s",cur->Issue,cur->Date);
			entryptr->next = NULL;
			entryptr->prev = prev;
			
			if (prev == NULL)	/* First entry in list */
				theIndex.head = entryptr;
			else
				prev->next = entryptr;
			
			prev = entryptr;
		}
		cur = cur->next;
	}
	
	sprintf (&comparestr[0],"%d issues of %s",theIndex.Lines,current->Title);
	strncpy (theIndex.Title,comparestr,20L);
	
	IndexHome();
	
	ClearPointer(IndexWindow);
}


/*  INDEX MOVEMENT ---------------------------------------------- */

void IndexScrollUp()
{
	struct RastPort *RP;
	
	if ( (theIndex.Lines < INDEXHEIGHT) ||
	     (theIndex.bottom->next == NULL) )
	     return;
	     
	RP = IndexWindow->RPort;
	
	/* Scroll the display up a line */
	ScrollRaster(RP,0,TEXTHEIGHT,WINDOWLEFT,WINDOWTOP,
		     WINDOWRIGHT,WINDOWBOTTOM + 1);
	
	/* Increment the display variables */
	theIndex.CurLine++;
	theIndex.top = theIndex.top->next;
	theIndex.bottom = theIndex.bottom->next;
	
	/* Print the last line of the display */
	Move (RP,WINDOWLEFT,WINDOWBOTTOM - TEXTHEIGHT + BASELINE);
	Text (RP,theIndex.bottom->string,strlen(theIndex.bottom->string));

	UpdateIndexProp();
}

void IndexScrollDown()
{
	struct RastPort *RP;
		
	if ( (theIndex.Lines < INDEXHEIGHT) ||
	     (theIndex.top->prev == NULL) )
	     return;
	     
	RP = IndexWindow->RPort;
	
	/* Scroll the display down a line */
	ScrollRaster(RP,0,-TEXTHEIGHT,WINDOWLEFT,WINDOWTOP,
		     WINDOWRIGHT,WINDOWBOTTOM - 1);
	
	/* Decrement the display variables */
	theIndex.CurLine--;
	theIndex.top = theIndex.top->prev;
	theIndex.bottom = theIndex.bottom->prev;
	
	/* Print the first line of the display */
	Move (RP,WINDOWLEFT,WINDOWTOP + BASELINE);
	Text (RP,theIndex.top->string,strlen(theIndex.top->string));

	UpdateIndexProp();
}

void IndexHome()
{
	register int i;
		
	/* Reset the display to top */
	theIndex.top = theIndex.head;
	theIndex.bottom = theIndex.top;
	for (i = 0;(i < INDEXHEIGHT-1) && (theIndex.bottom != NULL);i++)
	{	theIndex.bottom = theIndex.bottom->next;	}
		
	theIndex.CurLine = 1;

	IndexDisplay();
}

void ReadIndexProp()
{
	register int i;
	UWORD numlevels;
	UWORD level;
	
	numlevels = (UWORD) theIndex.Lines/INDEXHEIGHT;
	
	if (numlevels > 1)
	   level = (((ULONG)IndexProp_info.VertPot) * (numlevels-1) + MAXPOT/2) /MAXPOT;
	else
	   level = 0;
	   
	theIndex.CurLine = (int) (level * INDEXHEIGHT) + 1;
		
	theIndex.top = theIndex.head;
	for (i=1;i < theIndex.CurLine;i++)
	{	theIndex.top = theIndex.top->next;	}
	theIndex.bottom = theIndex.top;
	for (i=1;(i < INDEXHEIGHT) && (theIndex.bottom != NULL);i++)
	{	theIndex.bottom = theIndex.bottom->next;	}
		
	IndexDisplay();
}
		
/*  INDEX DISPLAY ROUTINES -------------------------------------- */

void IndexDisplay()
/*  Displays a windowful of  Index entries  */
{
	struct RastPort *RP;
	register IndexPtr entryptr;
	register int i;
	
	SetWindowTitles(IndexWindow,theIndex.Title,-1);
	
	RP = IndexWindow->RPort;
	
	/* Clear the index window */
	SetAPen(RP,0);
	RectFill(RP,WINDOWLEFT,WINDOWTOP,WINDOWRIGHT,WINDOWBOTTOM + 2);
	SetAPen(RP,3);
		
	/*  Print a windowful of index entries  */
	
	entryptr = theIndex.top;
	for (i = 0;(i < INDEXHEIGHT) && (entryptr !=NULL);i++)
	{
		Move (RP,WINDOWLEFT,(long) WINDOWTOP + i*TEXTHEIGHT + BASELINE);
		Text (RP,entryptr->string,strlen(entryptr->string));
		entryptr = entryptr->next;
	}
	UpdateIndexProp();
}

void UpdateIndexProp()
/*  Updates the Index window's proportional gadget  */
{
	USHORT NewBody,NewPot;
	UWORD hidden,top;
	
	hidden = theIndex.Lines - INDEXHEIGHT;
	if (hidden < 0) hidden = 0;
	
	top = theIndex.CurLine-1;
	
	if (top > hidden)
		top = hidden;
		
	NewBody = (hidden > 0) ? (UWORD) (((ULONG) (INDEXHEIGHT -1) *MAXBODY) / theIndex.Lines)
	                       : MAXBODY;
	NewPot = (hidden > 0) ? (UWORD) (((ULONG) top * MAXPOT)/hidden)
	                      : 0;
	
	NewModifyProp (&IndexProp,IndexWindow,NULL,IndexProp_info.Flags,
		       IndexProp_info.HorizPot,NewPot,
		       IndexProp_info.HorizBody,NewBody,1L);
}


/*  INDEX GO ROUTINES ------------------------------------------ */

char *SelectLine(yval)
SHORT yval;
/*  Returns the index entry of line clicked on  */
{
	int	theline,i;
	register IndexPtr	cur;
	
	theline = (int) ((yval - WINDOWTOP) / TEXTHEIGHT) + theIndex.CurLine;
	
	if ((theline < 1) || (theline > theIndex.Lines) ||
	    (theline > theIndex.CurLine + INDEXHEIGHT) )
	{
		return(NULL);
	}
	else
	{
		/* find the correct entry & return the string */
		cur = theIndex.head;
		for (i=1;(cur != NULL) && (i < theline);i++)
		{	cur = cur->next;	}
		return(cur->string);
	}	
}

void GotoIssue(yval)
SHORT yval;
{
	int	theissue,i,NewCurIssue;
	char	issuestring[100], *theptr;
	register ComicNodePtr	cur;
	
	theptr = SelectLine(yval);
	
	if (theptr)
	{
		/* Get issue number from index entry
		   Entry should be  "Issue : Date", so search for ':' */
		
		strcpy (issuestring,theptr);
		
		for (i = 0;issuestring[i] != ':';i++);
		issuestring[i] = '\0';
		
		theissue = atoi(&issuestring[0]);
		
		/* Find comic with issue number */
		cur = head;
		if (cur != NULL)
		{	strcpy (issuestring,cur->Title);
			ConvertStr(issuestring);	}
			
		NewCurIssue = 1;
		while ( (cur != NULL) &&
			(strcmp(theIndex.sttitle,issuestring) != 0) )
		{
			NewCurIssue++;
			cur = cur->next;
			strcpy (issuestring,cur->Title);
			ConvertStr(issuestring);
		}
		
		while ( (cur != NULL) && (cur->Issue != theissue) )
		{	NewCurIssue++;
			cur = cur->next;	}
		
		if (cur)
		{
			if (Comics.Changed)	SaveComic();
			previous = current;
			current = cur;
			CurIssue = NewCurIssue;
			DisplayComic();
			ActivateWindow(MainWindow);
		}
	}
}

void GotoTitle(yval)
SHORT yval;
{
	char	titlestring[INDEXWIDTH], *theptr;
	register ComicNodePtr	cur;
	int	NewCurIssue;
	
	theptr = SelectLine(yval);
	
	if (theptr)
	{
		/* Find comic with same title */
		strcpy (titlestring,theptr);
		
		NewCurIssue = 1;
		cur = head;	/* first issue of title */
		while ( (cur != NULL) &&
			(strncmp(cur->Title,titlestring,INDEXWIDTH)) )
		{	NewCurIssue++;
			cur = cur->next;	}
		
		if (cur)
		{
			if (Comics.Changed)	SaveComic();
			CurIssue = NewCurIssue;
			previous = current;
			current = cur;
			DisplayComic();
			ActivateWindow(MainWindow);
		}
	}
}

void IndexKeyAdvance(keycode)
char keycode;
{
	register ComicNodePtr cur;
	register int NewCurIssue;
	
	/*  Find the first title starting with keycode */
	keycode = toupper(keycode);
	NewCurIssue = 1;
	
	/*  Should we start looking from beginning or after this comic? */
	cur = head;
	if (keycode >= toupper(current->Title[0]) )
		cur = current->next;
		
	while ( (cur != NULL) && (toupper(cur->Title[0]) != keycode) )
	{
		cur = cur->next;
		NewCurIssue++;
	}
	
	/* did we find one? */
	if (cur != NULL)
	{
		if (Comics.Changed) SaveComic();
		
		previous = current;
		current = cur;
		CurIssue = NewCurIssue;
		DisplayComic();
		ActivateWindow(MainWindow);
	}
}


